# class Crypto::Bcrypt::Password

- Crypto::Bcrypt::Password
- Reference
- Object

## Overview

Generate, read and verify `Crypto::Bcrypt` hashes.

    require "crypto/bcrypt/password"

    password = Crypto::Bcrypt::Password.create("super secret", cost: 10)
    # => $2a$10$rI4xRiuAN2fyiKwynO6PPuorfuoM4L2PVv6hlnVJEmNLjqcibAfHq

    password == "wrong secret" # => false
    password == "super secret" # => true

See `Crypto::Bcrypt` for hints to select the cost when generating hashes.

## Defined in:

## Constructors

- .create(password, cost = DEFAULT_COST) : self

  Hashes a password.

- .new(raw_hash : String)

  Loads a bcrypt hash.

## Instance Method Summary

- #==(password : String) : Bool

  Verifies a password against the hash.

- #cost : Int32
- #digest : String
- #inspect(io)
- #salt : String
- #to_s(io)
- #version : String

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference)
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new

### Instance methods inherited from class `Object`

!=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, class class, dup dup, hash(hasher)
hash hash, inspect(io : IO)
inspect inspect, itself itself, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, tap(&block) tap, to_json(io : IO)
to_json to_json, to_pretty_json(indent : String = " ")
to_pretty_json(io : IO, indent : String = " ") to_pretty_json, to_s
to_s(io : IO) to_s, to_yaml(io : IO)
to_yaml to_yaml, try(&block) try, unsafe_as(type : T.class) forall T unsafe_as

### Constructor methods inherited from class `Object`

from_json(string_or_io, root : String) : self
from_json(string_or_io) : self from_json, from_yaml(string_or_io : String | IO) : self from_yaml

## Constructor Detail

def self.create(password, cost = DEFAULT_COST) : self #

Hashes a password.

    password = Crypto::Bcrypt::Password.create("super secret", cost: 10)
    # => $2a$10$rI4xRiuAN2fyiKwynO6PPuorfuoM4L2PVv6hlnVJEmNLjqcibAfHq

def self.new(raw_hash : String) #

Loads a bcrypt hash.

    password = Crypto::Bcrypt::Password.new("$2a$10$X6rw/jDiLBuzHV./JjBNXe8/Po4wTL0fhdDNdAdjcKN/Fup8tGCya")
    password.version # => "2a"
    password.salt    # => "X6rw/jDiLBuzHV./JjBNXe"
    password.digest  # => "8/Po4wTL0fhdDNdAdjcKN/Fup8tGCya"

## Instance Method Detail

def ==(password : String) : Bool #

Verifies a password against the hash.

    password = Crypto::Bcrypt::Password.create("super secret")
    password == "wrong secret" # => false
    password == "super secret" # => true

def cost : Int32 #
def digest : String #
def inspect(io) #
def salt : String #
def to_s(io) #
def version : String #